#!/usr/bin/env perl
#
# Author: Tomi Ollila -- too t iki fi
#
#	Copyright (c) 2003,2004 Tomi Ollila
#	    All rights reserved
#
# Created: Sat Mar  8 10:58:25 2003 too
# Last modified: Tue Oct 26 23:28:16 EEST 2004 too
#
# This program is licensed under the GPL v2. See file COPYING for details.

#
# This code can do LVE[MED|ETV]6 file format...
#
# This is a quick hack.
#

use strict;
use warnings;

#c# $0 = 'm2vmp2cut builtin lvev6frames.pl';

#c# wait;

sub usage
{

    print STDERR << "EOF";

Usage: $0 [filename]

	filename defaults to \$HOME/.lve/lveedit.lst

	... which is currently always used (i.e, no arg parsing implemented).

EOF
  exit 1;
}


sub LVEHDRSIZE () { 12 + 4 + 4 + 4 }

sub LVEBUFSIZE () { 4 + 4 + 4 + 4 + 4 + 4 + 4 + 4 + 4 + 1024 + 88 * 72 * 2 }

my $file = "$ENV{HOME}/.lve/lveedit.lst";

open(I, $file) || die "Cannot open $file: $!\n";

my $len = read I, my $buf, LVEHDRSIZE;

die "$len, LVEHDRSIZE" unless ($len == LVEHDRSIZE);

my ( $id, undef, $cnt, $dist_sum, $osize_mb ) = unpack("a8a4jjj", $buf);

die "$id != LVE(MED|EDT)V6\n" unless ($id eq "LVEEDTV6" || $id eq "LVEMEDV6");

my $prevfname = '';
my @line;
$" = ',';
while (($len = read I, $buf, LVEBUFSIZE) > 0)
{
    die "$len, LVEBUFSIZE" unless ($len == LVEBUFSIZE);

    my ( $mid, $vs, $as, $sr, $er, $dst, $s, $e, $avdb, $fname)
      = unpack("jjjjjjjjjZ1024", $buf);

    if ($prevfname && $fname ne $prevfname)
    {
 	print STDERR "Currently we can handle only lve edits that contains ",
 	  "only one line.\n";
 	exit 1;
    }
    $prevfname = $fname;
    $er += 1; # end if noninclusive in transcode, python, in this tool, and ...
    push @line, "$sr-$er";
}

print "$prevfname @line\n" if ($prevfname);
close I;

